require 'faraday'
require 'json'

module FlimperNikita
  module Notifications
    class Send
      def initialize(source:, severity:, message:, jwt_token:)
        @source = source
        @severity = severity
        @message = message
        @jwt_token = jwt_token
      end

      def nikita_api_endpoint
        "#{ENV.fetch('NIKITA_API_URL')}/notifications"
      end

      def security_data
        { source: @source, severity: @severity, message: @message }.to_json
      end

      def issue!
        nikita_response = Faraday.new.post do |request|
          request.url(nikita_api_endpoint)
          request.headers['Content-Type'] = 'application/json'
          request.headers['Authorization'] = @jwt_token
          request.body = security_data
        end

        return unless nikita_response.success?
      end
    end
  end
end
